package com.zoro.mutiDb.conf;

import java.util.HashMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.jdbc.datasource.lookup.AbstractRoutingDataSource;

import javax.sql.DataSource;
import java.util.Map;
import org.springframework.stereotype.Component;

@Component
@Primary
public class DynamicDataSource extends AbstractRoutingDataSource {
    @Autowired
    private DataSource masterOracleDataSource;
    @Autowired
    private DataSource masterDMDataSource;

    public static final ThreadLocal<String> DATASOURCE_HOLDER = new ThreadLocal<>();
//    public DynamicDataSource(DataSource defaultDataSource, Map<Object, Object> targetDataSource) {
//        super.setDefaultTargetDataSource(defaultDataSource);
//        super.setTargetDataSources(targetDataSource);
//    }

    @Override
    protected Object determineCurrentLookupKey() {
        return DATASOURCE_HOLDER.get();
    }

    @Override
    public void afterPropertiesSet(){
        HashMap<Object, Object> targetDataSources = new HashMap<>();
        targetDataSources.put("oracle",masterOracleDataSource);
        targetDataSources.put("dm",masterDMDataSource);
        super.setTargetDataSources(targetDataSources);
        super.setDefaultTargetDataSource(masterOracleDataSource);
        super.afterPropertiesSet();
    }
}
